/* Copyright (C) Gabriel T. Delarosa, 2010. 
 * All rights reserved worldwide.
 *
 * This software is provided "as is" without express or implied
 * warranties. You may freely copy and compile this source into
 * applications you distribute provided that the authors name is
 * mentioned.
 */
#include "Application.h"

namespace vi
{

template Application< OrthographicRenderer >;
template Application< PerspectiveRenderer >;
template Application< TerrainRenderer >;

template< class R >
Application< R >::Application()
{
}
template< class R >
void Application< R >::run( HWND hWnd )
{
    if( SUCCEEDED( renderer_.initD3D( hWnd ) ) )
    {
        if( SUCCEEDED( renderer_.init( viewport_ ) ) )
        {
            ShowWindow( hWnd, SW_SHOWDEFAULT );
            UpdateWindow( hWnd );

            MSG msg;
            ZeroMemory( &msg, sizeof(msg) );
            while( msg.message!=WM_QUIT )
            {
                if( PeekMessage( &msg, NULL, 0U, 0U, PM_REMOVE ) )
                {
                    TranslateMessage( &msg );
                    DispatchMessage( &msg );
                }
                else
                    renderer_.render( qcamera_, viewport_, airplane_ );
            }
        }
    }
}


}// end namespace