/* Copyright (C) Gabriel T. Delarosa, 2010. 
 * All rights reserved worldwide.
 *
 * This software is provided "as is" without express or implied
 * warranties. You may freely copy and compile this source into
 * applications you distribute provided that the authors name is
 * mentioned.
 */
#ifndef _APPLICATION_H
#define _APPLICATION_H

#include "OrthographicRenderer.h"
#include "PerspectiveRenderer.h"
#include "TerrainRenderer.h"

namespace vi
{

template< class R >
class Application
{
public:
    Application( );

    QCamera *getCamera() { return &qcamera_; }
    ViewPort *getViewPort() { return &viewport_; }
    RendererBase *getRenderer() { return &renderer_; }
	Airplane *getAirplane() { return &airplane_; }
    
    void run( HWND hWnd );

private:
    QCamera    qcamera_;
    ViewPort   viewport_;

    R          renderer_;

    Airplane   airplane_;  
};

}// end namespace

#endif