/* Copyright (C) Gabriel T. Delarosa, 2010. 
 * All rights reserved worldwide.
 *
 * This software is provided "as is" without express or implied
 * warranties. You may freely copy and compile this source into
 * applications you distribute provided that the authors name is
 * mentioned.
 */
#ifndef _EDGE_H
#define _EDGE_H

#include <d3dx9math.h>

namespace vi
{

struct Edge
{
    Edge( const D3DXVECTOR2& a,const D3DXVECTOR2& b ) :
        yMax_( a.y ),
        yMin_( b.y ),
        deltaX_( -( a.x - b.x ) / ( yMax_ - yMin_ ) ),
        curX_( a.x - deltaX_*( static_cast<int>(yMax_+1) - yMax_ ) )
    {
    }
    void update()
    {
        curX_ += deltaX_;
    }

    float getStep() { return ceil( fabs( deltaX_ ) ); }

    float yMax_;
    float yMin_;

    float deltaX_;
    float curX_;
};

}//end namespace

#endif