/* Copyright (C) Gabriel T. Delarosa, 2010. 
 * All rights reserved worldwide.
 *
 * This software is provided "as is" without express or implied
 * warranties. You may freely copy and compile this source into
 * applications you distribute provided that the authors name is
 * mentioned.
 */

#ifndef _ORTHO_RENDER_H
#define _ORTHO_RENDER_H

#include "RendererBase.h"

namespace vi
{

class OrthographicRenderer : public RendererBase
{
protected:
    struct CUSTOMVERTEX
    {
        D3DXVECTOR3 position;
        D3DCOLOR    color;
    };
    #define D3DFVF_CUSTOMVERTEX (D3DFVF_XYZ|D3DFVF_DIFFUSE)

public:
    HRESULT   init( const ViewPort &vp );
    void      renderCameraFootprint( const std::vector<D3DXVECTOR3> &clippedPts, D3DXVECTOR3 eye, float viewDist );

};

}// end namespace

#endif