/* Copyright (C) Gabriel T. Delarosa, 2010. 
 * All rights reserved worldwide.
 *
 * This software is provided "as is" without express or implied
 * warranties. You may freely copy and compile this source into
 * applications you distribute provided that the authors name is
 * mentioned.
 */

#ifndef _PERSP_RENDER_H
#define _PERSP_RENDER_H

#include "RendererBase.h"

namespace vi
{

class PerspectiveRenderer : public RendererBase
{
protected:
    struct TEXTRVERTEX
    {
        D3DXVECTOR3 position;
        FLOAT       tu, tv;
        FLOAT       ts, tt;
    };
    #define D3DFVF_TEXTRVERTEX ( D3DFVF_XYZ | D3DFVF_TEX2 )

    enum tex_name
    {
        LOW_GRND,
        HIGH_GRND,
        STONE
    };

public:
    virtual HRESULT  init( const ViewPort &vp );
    void             renderCameraFootprint( const std::vector<D3DXVECTOR3> &clippedPts, D3DXVECTOR3 eye, float viewDist );

protected:
    LPDIRECT3DTEXTURE9  textures_[3];
};

}// end namespace

#endif