/* Copyright (C) Gabriel T. Delarosa, 2010. 
 * All rights reserved worldwide.
 *
 * This software is provided "as is" without express or implied
 * warranties. You may freely copy and compile this source into
 * applications you distribute provided that the authors name is
 * mentioned.
 */

#ifndef _QCAMERA_H
#define _QCAMERA_H

#include <d3dx9math.h>

namespace vi
{

class QCamera
{
public:
    QCamera();
    QCamera( float posX,  float posY,  float posZ,
             float lookAtX, float lookAtY, float lookAtZ,
             float upX,   float upY,   float upZ );

    void set( float posX,  float posY,  float posZ,
              float lookAtX, float lookAtY, float lookAtZ,
              float upX,   float upY,   float upZ );

    const D3DXVECTOR3 eye() const { return eye_; }
    const D3DXVECTOR3 up() const { return up_; }
    const D3DXVECTOR3 side() const { return side_; }
    const D3DXVECTOR3 lookAt() const { return lookAt_; }
    const D3DXQUATERNION orientation()const { return quat_; }

    void translate( float x, float y, float z );
    void yawPitchRoll( float y, float p, float r );

    void update();

private:
    D3DXQUATERNION  quat_;

    D3DXVECTOR3     eye_;
    D3DXVECTOR3     up_;
    D3DXVECTOR3     side_;
    D3DXVECTOR3     lookAt_;

};

}// end namespace

#endif