/* Copyright (C) Gabriel T. Delarosa, 2010. 
 * All rights reserved worldwide.
 *
 * This software is provided "as is" without express or implied
 * warranties. You may freely copy and compile this source into
 * applications you distribute provided that the authors name is
 * mentioned.
 */

//-----------------------------------------------------------------------------
#include "Application.h"

static Airplane *s_TheAirplane = 0;

//-----------------------------------------------------------------------------
LRESULT WINAPI MsgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
    float ang_inc = 0.009f;
    float vert_inc = 0.5f;
    float speed = 1.0f;

    switch( msg )
    {
        case WM_DESTROY:
            PostQuitMessage( 0 );
            return 0;

        case WM_KEYDOWN:
            switch( LOWORD( wParam ) )         
            {            
            //// Escape
            case VK_ESCAPE : DestroyWindow(hWnd);break;
            case 'Z'  :  s_TheAirplane->yaw_ = -ang_inc*6; break;
            case 'C' :  s_TheAirplane->yaw_ = ang_inc*6;break;
            case 'W'    :  s_TheAirplane->pitch_ = ang_inc*2;break;
            case 'S'  :  s_TheAirplane->pitch_ = -ang_inc*2;break;

            case 'A'  :  s_TheAirplane->roll_ = -ang_inc*3;break;
            case 'D'  :  s_TheAirplane->roll_ = ang_inc*3;break;

            case 'Q'  :  s_TheAirplane->climbRate_ = vert_inc;break;
            case 'E'  :  s_TheAirplane->climbRate_ = -vert_inc;break;

            case 38   :  s_TheAirplane->speed_ = speed;break;
            case 40   :  s_TheAirplane->speed_ = -speed;break;
            }
            break;
        case WM_KEYUP:        
            switch( LOWORD( wParam ) )         
            {
            case 'Z'  :  s_TheAirplane->yaw_ = 0.0f; break;
            case 'C' :  s_TheAirplane->yaw_ = 0.0f;break;
            case 'W'  :  s_TheAirplane->pitch_ = 0.0f;break;
            case 'S'  :  s_TheAirplane->pitch_ = 0.0f;break;

            case 'A'  :  s_TheAirplane->roll_ = 0.0f;break;
            case 'D'  :  s_TheAirplane->roll_ = 0.0f;break;
            case 'Q'  :  s_TheAirplane->climbRate_ = 0.0f;break;
            case 'E'  :  s_TheAirplane->climbRate_ = 0.0f;break;
            case 38   :  s_TheAirplane->speed_ = 0.0f;break;
            case 40   :  s_TheAirplane->speed_ = 0.0f;break;
            }
            break;
    }

    return DefWindowProc( hWnd, msg, wParam, lParam );
}

//-----------------------------------------------------------------------------
INT WINAPI WinMain( HINSTANCE hInst, HINSTANCE, LPSTR, INT )
{
    //vi::Application<vi::OrthographicRenderer> app;
    //vi::Application<vi::PerspectiveRenderer> app;
    vi::Application<vi::TerrainRenderer> app;

	s_TheAirplane = app.getAirplane();

    vi::ViewPort *vp = app.getViewPort();
    assert( vp );

    WNDCLASSEX wc = { sizeof(WNDCLASSEX), CS_CLASSDC, MsgProc, 0L, 0L,
                      GetModuleHandle(NULL), NULL, NULL, NULL, NULL,
                      "Virtual Infinity", NULL };
    RegisterClassEx( &wc );

    HWND hWnd = CreateWindow( "Virtual Infinity", "Virtual Infinity",
                              WS_OVERLAPPEDWINDOW, 100, 100, 
                              static_cast<int>( vp->screenWidth() ),
                              static_cast<int>( vp->screenHeight() ),
                              GetDesktopWindow(), NULL, wc.hInstance, NULL );

    app.run( hWnd );
    UnregisterClass( "Virtual Infinity", wc.hInstance );
    return 0;
}

